"""
This program checks the underlying type object for int32 data types.
"""

import platform
import numpy as num


ROWHDR_WIDTH = 15

NAME_COLWIDTH = 11
STR_COLWIDTH = 10
KIND_COLWIDTH = 11
CHAR_COLWIDTH = 11
ID_COLWIDTH = 10

NUM_BITS = platform.architecture()[0]

def show(a, t):
    element = a.flatten()[0]
    print ('%s | %s | %s | %s | %s | %10x |'
           % (t.rjust(ROWHDR_WIDTH),
              a.dtype.name.center(NAME_COLWIDTH),
              a.dtype.str.center(STR_COLWIDTH),
              a.dtype.kind.center(KIND_COLWIDTH),
              a.dtype.char.center(CHAR_COLWIDTH),
              id(type(element)))
          )

print ("This table shows 'dtype' attributes for the '32bit integer' types on a "
       "%s platform:" % NUM_BITS)

print ''
print ('%s | .dtype.name | .dtype.str | .dtype.kind | .dtype.char | id(type)     |'
       % ' '.rjust(ROWHDR_WIDTH))
print ('%s-+-------------+------------+-------------+-------------+--------------+'
       % '-'.rjust(ROWHDR_WIDTH))

# check all attributes of 'numpy', ignore that cause exception.
for t in dir(num):
    try:
        a = eval('num.array([[1,2],[3,4]], dtype=num.%s)' % t)
    except (TypeError, ValueError):
        pass
    else:
#        if a.dtype.name != 'object':
        if a.dtype.name == 'int32':
            show(a, t)

print ('%s-+-------------+------------+-------------+-------------+--------------+'
       % '-'.rjust(ROWHDR_WIDTH))
